<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <div class="pull-right">
        <button type="submit" form="form-fpcarousel" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
        <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
      <h1><?php echo $heading_title; ?></h1>
      <ul class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
        <?php } ?>
      </ul>
    </div>
  </div>
  <div class="container-fluid">
    <?php if ($error_warning) { ?>
    <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
      <button type="button" class="close" data-dismiss="alert">&times;</button>
    </div>
    <?php } ?>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
      </div>
      <div class="panel-body">
        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-fpcarousel" class="form-horizontal">
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-name"><?php echo $entry_name; ?></label>
            <div class="col-sm-10">
              <input type="text" name="name" value="<?php echo $name; ?>" placeholder="<?php echo $entry_name; ?>" id="input-name" class="form-control" />
              <?php if ($error_name) { ?>
              <div class="text-danger"><?php echo $error_name; ?></div>
              <?php } ?>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_name_as_title; ?>"><?php echo $entry_name_as_title; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="name_as_title" id="input-name_as_title" class="form-control">
					<?php if ($name_as_title) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>          
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-product"><?php echo $entry_product; ?></label>
            <div class="col-sm-10">
              <input type="text" name="product" value="" placeholder="<?php echo $entry_product; ?>" id="input-product" class="form-control" />
              <div id="fpcarousel-product" class="well well-sm" style="height: 150px; overflow: auto;">
                <?php foreach ($products as $product) { ?>
                <div id="fpcarousel-product<?php echo $product['product_id']; ?>"><i class="fa fa-minus-circle"></i> <?php echo $product['name']; ?>
                  <input type="hidden" name="product[]" value="<?php echo $product['product_id']; ?>" />
                </div>
                <?php } ?>
              </div>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-limit"><?php echo $entry_limit; ?></label>
            <div class="col-sm-10">
              <input type="text" name="limit" value="<?php echo $limit; ?>" placeholder="<?php echo $entry_limit; ?>" id="input-limit" class="form-control" />
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label"><?php echo $entry_itemspage; ?></label>
            <div class="col-sm-10">
              <input class="form-control" name="itemspage" value="<?php echo $itemspage; ?>" size="3" /> 
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_shuffle_items; ?>"><?php echo $entry_shuffle_items; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="shuffle_items" id="input-shuffle_items" class="form-control">
					<?php if ($shuffle_items) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_auto_play; ?>"><?php echo $entry_auto_play; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="auto_play" id="input-auto_play" class="form-control">
					<?php if ($auto_play) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_pause_on_hover; ?>"><?php echo $entry_pause_on_hover; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="pause_on_hover" id="input-pause_on_hover" class="form-control">
					<?php if ($pause_on_hover) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_show_pagination; ?>"><?php echo $entry_show_pagination; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="show_pagination" id="input-show_pagination" class="form-control">
					<?php if ($show_pagination) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_show_navigation; ?>"><?php echo $entry_show_navigation; ?></span>
			</label>
            <div class="col-sm-10">
				<select name="show_navigation" id="input-show_navigation" class="form-control">
					<?php if ($show_navigation) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				</select>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-thumb_width"><?php echo $entry_thumb_size; ?></label>
            <div class="col-sm-5">
              <input type="text" name="thumb_width" value="<?php echo $thumb_width; ?>" placeholder="<?php echo $entry_thumb_width; ?>" id="input-thumb_width" class="form-control" />
              <?php if ($error_thumb_width) { ?>
              <div class="text-danger"><?php echo $error_thumb_width; ?></div>
              <?php } ?>
            </div>
            <div class="col-sm-5">
              <input type="text" name="thumb_height" value="<?php echo $thumb_height; ?>" placeholder="<?php echo $entry_thumb_height; ?>" id="input-thumb_height" class="form-control" />
              <?php if ($error_thumb_height) { ?>
              <div class="text-danger"><?php echo $error_thumb_height; ?></div>
              <?php } ?>
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
            <div class="col-sm-10">
              <select name="status" id="input-status" class="form-control">
                <?php if ($status) { ?>
                <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                <option value="0"><?php echo $text_disabled; ?></option>
                <?php } else { ?>
                <option value="1"><?php echo $text_enabled; ?></option>
                <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                <?php } ?>
              </select>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
  <script type="text/javascript"><!--
$('input[name=\'product\']').autocomplete({
	source: function(request, response) {
		$.ajax({
			url: 'index.php?route=catalog/product/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request),
			dataType: 'json',
			success: function(json) {
				response($.map(json, function(item) {
					return {
						label: item['name'],
						value: item['product_id']
					}
				}));
			}
		});
	},
	select: function(item) {
		$('input[name=\'product\']').val('');
		
		$('#fpcarousel-product' + item['value']).remove();
		
		$('#fpcarousel-product').append('<div id="fpcarousel-product' + item['value'] + '"><i class="fa fa-minus-circle"></i> ' + item['label'] + '<input type="hidden" name="product[]" value="' + item['value'] + '" /></div>');	
	}
});
	
$('#fpcarousel-product').delegate('.fa-minus-circle', 'click', function() {
	$(this).parent().remove();
});
//--></script></div>
<?php echo $footer; ?>
