<?php
/**
 * Popup Box Module Pro
 * 
 * @author  Cuispi
 * @version 2.0.3
 * @license Commercial License
 * @package system
 * @subpackage  system.library.popup_box
 */

$file = DIR_SYSTEM . 'library/popup_box/popup_box_base.php';

if (file_exists($file) && is_readable($file)) {
  require_once $file;
}

class PopupBox {

  /**
   * Registry
   *
   * @var object
   */     
  private static $registry;

  /**
   * Constructor.
   *
   * @param object $registry
   */  
	public function __construct($registry) {    
    self::$registry = $registry;
  }
  
  /**
   * Show the module for a given module id.
   *
   * @param  integer $id  Module id
   * @return PopupBoxBase::show()
   */     
  public static function show($id) {
    if (!class_exists('PopupBoxBase')) {
      return false;
    }

    return PopupBoxBase::getInstance()->init(self::$registry)->show($id);
  }

  /**
   * Show the module for a given array of setting values.
   *
   * @param  array $setting
   * @return PopupBoxBase::render()
   */ 
  public static function render($setting) {
    if (!class_exists('PopupBoxBase')) {
      return false;
    }

    return PopupBoxBase::getInstance()->init(self::$registry)->render($setting);
  }  

  /**
   * Get the current version of the module.
   *
   * @param void
   * @return PopupBoxBase::getVersion()
   */
  public static function version() {
    if (!class_exists('PopupBoxBase')) {
      return false;
    }
    
    return PopupBoxBase::getInstance()->getVersion();
  }  
  
}
