<?php
class ModelCatalogManufacturer extends Model {
	public function addManufacturer($data) {
		$this->event->trigger('pre.admin.manufacturer.add', $data);

		$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "'");

		$manufacturer_id = $this->db->getLastId();

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET image = '" . $this->db->escape($data['image']) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
		}
                //BUPS
		if (isset($data['topleft_png']) ) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keeptopleft'])  && $data['keeptopleft']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(topleft_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
		if (isset($data['topright_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keeptopright']) && $data['keeptopright']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(topright_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
		if (isset($data['bottomleft_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keepbottomleft']) && $data['keepbottomleft']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(bottomleft_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }

		if (isset($data['bottomright_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keepbottomright']) && $data['keepbottomright']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(bottomright_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
                //end


		if (isset($data['manufacturer_store'])) {
			foreach ($data['manufacturer_store'] as $store_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer_to_store SET manufacturer_id = '" . (int)$manufacturer_id . "', store_id = '" . (int)$store_id . "'");
			}
		}

		if (isset($data['keyword'])) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");
		}

		$this->cache->delete('manufacturer');

		$this->event->trigger('post.admin.manufacturer.add', $manufacturer_id);

		return $manufacturer_id;
	}

	public function editManufacturer($manufacturer_id, $data) {
		$this->event->trigger('pre.admin.manufacturer.edit', $data);

		$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		if (isset($data['image'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET image = '" . $this->db->escape($data['image']) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
		}
                //BUPS
		if (isset($data['topleft_png']) ) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keeptopleft'])  && $data['keeptopleft']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(topleft_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topleft_png = '" . $this->db->escape(html_entity_decode($data['topleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
		if (isset($data['topright_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keeptopright']) && $data['keeptopright']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(topright_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET topright_png = '" . $this->db->escape(html_entity_decode($data['topright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
		if (isset($data['bottomleft_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keepbottomleft']) && $data['keepbottomleft']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(bottomleft_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomleft_png = '" . $this->db->escape(html_entity_decode($data['bottomleft_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }

		if (isset($data['bottomright_png'])) {
                    $this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
                    $query2 = $this->db->query("SELECT product_id FROM `" . DB_PREFIX . "product` WHERE manufacturer_id = '" . (int)$manufacturer_id. "' ");
                    foreach ($query2->rows as $result2) {
                        if (isset($data['keepbottomright']) && $data['keepbottomright']==1) 
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' AND NULLIF(bottomright_png,'') IS NULL");
                        else
                                $this->db->query("UPDATE `" . DB_PREFIX . "product` SET bottomright_png = '" . $this->db->escape(html_entity_decode($data['bottomright_png'], ENT_QUOTES, 'UTF-8')). "' WHERE product_id = '" . (int)$result2['product_id'] . "' ");
                    }
                }
                //end


		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		if (isset($data['manufacturer_store'])) {
			foreach ($data['manufacturer_store'] as $store_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer_to_store SET manufacturer_id = '" . (int)$manufacturer_id . "', store_id = '" . (int)$store_id . "'");
			}
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

		if ($data['keyword']) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");
		}

		$this->cache->delete('manufacturer');

		$this->event->trigger('post.admin.manufacturer.edit', $manufacturer_id);
	}

	public function deleteManufacturer($manufacturer_id) {
		$this->event->trigger('pre.admin.manufacturer.delete', $manufacturer_id);

		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

		$this->cache->delete('manufacturer');

		$this->event->trigger('post.admin.manufacturer.delete', $manufacturer_id);
	}

	public function getManufacturer($manufacturer_id) {
		$query = $this->db->query("SELECT DISTINCT *, (SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "') AS keyword FROM " . DB_PREFIX . "manufacturer WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		return $query->row;
	}

	public function getManufacturers($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "manufacturer";

		if (!empty($data['filter_name'])) {
			$sql .= " WHERE name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getManufacturerStores($manufacturer_id) {
		$manufacturer_store_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		foreach ($query->rows as $result) {
			$manufacturer_store_data[] = $result['store_id'];
		}

		return $manufacturer_store_data;
	}

	public function getTotalManufacturers() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "manufacturer");

		return $query->row['total'];
	}
}
