<?php
class ControllerModuleBestSeller extends Controller {
	public function index($setting) {
		$this->load->language('module/bestseller');

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_tax'] = $this->language->get('text_tax');

		$data['button_cart'] = $this->language->get('button_cart');
		$data['button_wishlist'] = $this->language->get('button_wishlist');
		$data['button_compare'] = $this->language->get('button_compare');

		$this->load->model('catalog/product');

		$this->load->model('tool/image');

		$data['products'] = array();

		$results = $this->model_catalog_product->getBestSellerProducts($setting['limit']);

		if ($results) {
			foreach ($results as $result) {
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'], $setting['width'], $setting['height']);
//BUPS
                                if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
                                    $http = $this->config->get('config_ssl') . 'image/';
                                } else {
                                    $http = $this->config->get('config_url') . 'image/';
                                }
                                if (isset($this->request->get['store_id'])) {
                                    $store_id = $this->request->get['store_id'];
                                } else {
                                    $store_id = 0;
                                }
                                $this->load->model('setting/setting');
                                $settings = $this->model_setting_setting->getSetting('labelimage', $store_id);
                                if (isset($settings['labelimage_bestseller']) && $settings['labelimage_bestseller']=='1' && $settings['labelimage_status']=='1'){
                                    if ($result['topleft_png'] || $result['topright_png'] || $result['bottomleft_png'] || $result['bottomright_png']){
                                        $this->load->model('tool/labelimage');
                                        
                                        $image = $this->model_tool_labelimage->setLabelImage($image, $result['topleft_png'], $result['topright_png'], $result['bottomleft_png'], $result['bottomright_png'],$http,$result['image'],$result['product_id'], $setting['width'], $setting['height'], $settings['labelimage_productexpros'], $settings['labelimage_autoresize']);
                                    }
                                }
                                //end

				} else {
					$image = $this->model_tool_image->resize('placeholder.png', $setting['width'], $setting['height']);
				}

				if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
					$price = $this->currency->format($this->tax->calculate($result['price'], $result['tax_class_id'], $this->config->get('config_tax')));
				} else {
					$price = false;
				}

				if ((float)$result['special']) {
					$special = $this->currency->format($this->tax->calculate($result['special'], $result['tax_class_id'], $this->config->get('config_tax')));
				} else {
					$special = false;
				}

				if ($this->config->get('config_tax')) {
					$tax = $this->currency->format((float)$result['special'] ? $result['special'] : $result['price']);
				} else {
					$tax = false;
				}

				if ($this->config->get('config_review_status')) {
					$rating = $result['rating'];
				} else {
					$rating = false;
				}

				
            $button_stock = $result['quantity'] <= 0 ? $result['stock_status'] : $data['button_cart'];
            
            $data['products'][] = array(
                'contact_block'  => $result['quantity'],
                'button_stock'  => $button_stock,
            
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8')), 0, $this->config->get('config_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'rating'      => $rating,
					'href'        => $this->url->link('product/product', 'product_id=' . $result['product_id'])
				);
			}

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/bestseller.tpl')) {
				return $this->load->view($this->config->get('config_template') . '/template/module/bestseller.tpl', $data);
			} else {
				return $this->load->view('default/template/module/bestseller.tpl', $data);
			}
		}
	}
}
