<?php
//========== Popup Box: BEGIN ==========
        if (is_file(DIR_SYSTEM . 'library/popup_box/popup_box.php')) {
          require_once DIR_SYSTEM . 'library/popup_box/popup_box.php';
        }
        //========== Popup Box: END ============
final class Front {
	private $registry;
	private $pre_action = array();
	private $error;

	public function __construct($registry) {
		$this->registry = $registry;
	}

	public function addPreAction($pre_action) {
		$this->pre_action[] = $pre_action;
	}

	public function dispatch($action, $error) {
		$this->error = $error;

		foreach ($this->pre_action as $pre_action) {
			$result = $this->execute($pre_action);

			if ($result) {
				$action = $result;

				break;
			}
		}

//========== Popup Box: BEGIN ==========
        if (!$this->registry->has('popup_box')) {
          if (class_exists('PopupBox')) {
            $popup_box = new PopupBox($this->registry);
            $this->registry->set('popup_box', $popup_box);
          }
        }
        //========== Popup Box: END ============
		while ($action) {
			$action = $this->execute($action);
		}
	}

	private function execute($action) {
		$result = $action->execute($this->registry);

		if (is_object($result)) {
			$action = $result;
		} elseif ($result === false) {
			$action = $this->error;

			$this->error = '';
		} else {
			$action = false;
		}

		return $action;
	}
}