<?php
class ControllerCommonColumnLeft extends Controller {
	public function index() {
		$this->load->model('design/layout');

		if (isset($this->request->get['route'])) {
			$route = (string)$this->request->get['route'];
		} else {
			$route = 'common/home';
		}

		$layout_id = 0;

		if ($route == 'product/category' && isset($this->request->get['path'])) {
			$this->load->model('catalog/category');

			$path = explode('_', (string)$this->request->get['path']);

			$layout_id = $this->model_catalog_category->getCategoryLayoutId(end($path));
		}

		if ($route == 'product/product' && isset($this->request->get['product_id'])) {
			$this->load->model('catalog/product');

			$layout_id = $this->model_catalog_product->getProductLayoutId($this->request->get['product_id']);
		}

		if ($route == 'information/information' && isset($this->request->get['information_id'])) {
			$this->load->model('catalog/information');

			$layout_id = $this->model_catalog_information->getInformationLayoutId($this->request->get['information_id']);
		}
                //============-- Start Blog --===================//
                if ($route == 'blog/category' && isset($this->request->get['path'])) {
                    $this->load->model('blog/category');

                    $path = explode('_', (string)$this->request->get['path']);

                    $layout_id = $this->model_blog_category->getCategoryLayoutId(end($path));
                }

                if ($route == 'blog/single' && isset($this->request->get['pid'])) {
                    $this->load->model('blog/post');

                    $layout_id = $this->model_blog_post->getPostLayoutId($this->request->get['pid']);
                }

                if ($route == 'blog/tag' && isset($this->request->get['pid'])) {
                    $this->load->model('blog/post');

                    $layout_id = $this->model_blog_post->getPostLayoutId($this->request->get['pid']);
                }
                //============-- End Blog --===================//

		if (!$layout_id) {
			$layout_id = $this->model_design_layout->getLayout($route);
		}

		if (!$layout_id) {
			$layout_id = $this->config->get('config_layout_id');
		}

		$this->load->model('extension/module');

		$data['modules'] = array();

		$modules = $this->model_design_layout->getLayoutModules($layout_id, 'column_left');

		foreach ($modules as $module) {
			$part = explode('.', $module['code']);

			if (isset($part[0]) && $this->config->get($part[0] . '_status')) {
				$data['modules'][] = $this->load->controller('module/' . $part[0]);
			}

			if (isset($part[1])) {
				$setting_info = $this->model_extension_module->getModule($part[1]);

				if ($setting_info && $setting_info['status']) {
					$data['modules'][] = $this->load->controller('module/' . $part[0], $setting_info);
				}
			}
		}


                if ($this->config->get('config_template') == 'default2') {
                    $this->load->model('extension/default2');

                    $blockToLoad = array('sidebar_left');
                    $data += $this->model_extension_default2->getAllPosition($blockToLoad);
                }
            
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/column_left.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/common/column_left.tpl', $data);
		} else {
			return $this->load->view('default/template/common/column_left.tpl', $data);
		}
	}
}